import xbmc, xbmcaddon, xbmcgui, xbmcplugin
import os

ADDON = xbmcaddon.Addon(id='plugin.video.whatthefurk')
DATA_PATH = os.path.join(xbmc.translatePath('special://profile/addon_data/plugin.video.whatthefurk'), '')
ADDON_PATH = xbmc.translatePath(os.path.join('special://home/addons/plugin.video.whatthefurk', ''))

def addon():
    return ADDON

def enable_subscriptions():
    if ADDON.getSetting('enable_subscriptions') == "true":
        return True
    else:
        return False
		
def enable_meta():
    if ADDON.getSetting('enable_meta') == "true":
        return True
    else:
        return False
		
def autoplay():
    if ADDON.getSetting('autoplay_movie') == "true":
        return True
    else:
        return False
		
def autoplay_arch():
    option = ADDON.getSetting('autoplay_archive')
    if option == '0':
        return 'm'
    elif option == '1':
        return 't'
    elif option == '2':
        return 'b'
    else:
        return 'n'
		
def incl_year_tv():
    if ADDON.getSetting('incl_year_tv') == "true":
        return True
    else:
        return False
		
def delay_subs():
    if ADDON.getSetting('delay_subs') == "true":
        return True
    else:
        return False
	
def favourites_file():
    return create_file(DATA_PATH, "favourites.list")
	
def favourites_TV_file():
    return create_file(DATA_PATH, "favourites_TV.list")
	
def favourites_MUSIC_file():
    return create_file(DATA_PATH, "favourites_MUSIC.list")
	
def favourites_artists_file():
    return create_file(DATA_PATH, "favourites_artists.list")
	
def favourites_albums_file():
    return create_file(DATA_PATH, "favourites_albums.list")
	
def subscription_file():
    return create_file(DATA_PATH, "subscriptions.list")
	
def addon():
    return ADDON

def data_path():
    return DATA_PATH

def cache_path():
    return create_directory(DATA_PATH, "cache")

def cookie_jar():
    return create_file(DATA_PATH, "cookiejar.lwp")
	
def imdb_actor_file():
    return create_file(DATA_PATH, "imdb_actors.list")

def downloads_file():
    return create_file(DATA_PATH, "active_downloads.list")
	
def downloads_file_tv():
    return create_file(DATA_PATH, "active_downloads_tv.list")
	

def people_list():
    return create_file(DATA_PATH, "people_list.list")
	

def disable_dialog():
    return ADDON.getSetting('disable_dialog')

def download_speed():
    return ADDON.getSetting('download_speed')
	
def temp_path():
    return ADDON.getSetting('temp_path')
		
def skip_file_browse():
    if ADDON.getSetting('skip_file_browse') == "true":
        return True
    else:
        return False
		
def show_rating():
    if ADDON.getSetting('show_rating') == "true":
        return True
    else:
        return False

def furk_moderated():
    if ADDON.getSetting('furk_moderated') == "true":
        return "yes"
    else:
        return "no"

def restrict_trailer():
    if ADDON.getSetting('restrict_trailer') == "true":
        return True
    else:
        return False
		
def trailer_quality():
    quality = ADDON.getSetting('trailer_quality')
    if quality == '0':
        return '480p'
    elif quality == '1':
        return '720p'
    else:
        return '1080p'
		
def furkdelay():
    delay = ADDON.getSetting('furkdelay')
    if delay == '0':
        return 0
    elif delay == '1':
        return 1
    elif delay == '2':
        return 2
    elif delay == '3':
        return 3
    elif delay == '4':
        return 4
    else:
        return 5
		
def trailer_one_click():
    if ADDON.getSetting('trailer_one_click') == "true":
        return True
    else:
        return False
		
def download_subtitles():
    if ADDON.getSetting('download_subtitles') == "true":
        return True
    else:
        return False

def oneclick_search():
    if ADDON.getSetting('oneclick_search') == "true":
        return True
    else:
        return False
		
def lib_format():
    if ADDON.getSetting('lib_format') == "true":
        return True
    else:
        return False

def show_unaired():
    if ADDON.getSetting('show_unaired') == "true":
        return True
    else:
        return False
		
def show_special():
    if ADDON.getSetting('show_special') == "true":
        return True
    else:
        return False
		
def nzvmovie_url():
    return "http://www.nzbmovieseeker.com/"
  
def imdb_actors_url():
    return "http://www.imdb.com/search/name?"
		
def imdb_search_url():
    region = ADDON.getSetting('imdb_region')
    if region == '0':
        return "http://akas.imdb.com/"
    else:
        return "http://www.imdb.com/"
	
def imdb_list_url():
    region = ADDON.getSetting('imdb_region')
    if region == '0':
        return "http://akas.imdb.com/list/"
    else:
        return "http://www.imdb.com/list/"
	
def imdb_watchlist_url():
    region = ADDON.getSetting('imdb_region')
    if region == '0':
        return "http://akas.imdb.com/user/" + ADDON.getSetting('imdb_user') + "/watchlist?"
    else:
        return "http://www.imdb.com/user/" + ADDON.getSetting('imdb_user') + "/watchlist?"

def imdb_filter_status():
    return "released"

def qualitystyle():
    style = ADDON.getSetting('qualitystyle')
    if style == '0':
        return "preferred"
    else:
        return "full list"
		
def qualitystyle_tv():
    style = ADDON.getSetting('qualitystyle_tv')
    if style == '0':
        return "preferred"
    else:
        return "full list"

	
def furk_limit_result():
    limit = ADDON.getSetting('furk_limit_result')
    if limit == '0':
        return 1
    elif limit == '1':
        return 3
    elif limit == '2':
        return 5
    elif limit == '3':
        return 10
    elif limit == '4':
        return 15
    elif limit == '5':
        return 20
    elif limit == '6':
        return 25
    elif limit == '7':
        return 50
    else:
        return 25

def furk_sort():
    furk_sort = ADDON.getSetting('furk_sort')
    if furk_sort == '0':
        return 'cached'
    elif furk_sort == '1':
        return 'relevance'
    elif furk_sort == '2':
        return 'size'
    elif furk_sort == '3':
        return 'date'
    else:
        return 'cached,size'

def furk_results():
    furk_results = ADDON.getSetting('furk_results')
    if furk_results == '0':
        return 'all'
    elif furk_results == '1':
        return 'cached'
    else:
        return 'cached'

def custom_quality():
    quality = ADDON.getSetting('quality')
    if quality == '0':
        return 'CAM'
    elif quality == '1':
        return 'TS'
    elif quality == '2':
        return 'TELESYNC'
    elif quality == '3':
        return 'R5'
    elif quality == '4':
        return 'DVDSCR'
    elif quality == '5':
        return 'DVDRIP'
    elif quality == '6':
        return 'HDTV'
    elif quality == '7':
        return 'BRRIP'
    elif quality == '8':
        return 'BDRIP'
    elif quality == '9':
        return '480P'
    elif quality == '10':
        return '720P'
    elif quality == '11':
        return '1080P'
    elif quality == '12':
        return ''
    else:
        return '720P'
		
def preferred2():
    if ADDON.getSetting('search_quality_2') == "true":
        return True
    else:
        return False
		
def custom_quality2():
    quality = ADDON.getSetting('quality2')
    if quality == '0':
        return 'CAM'
    elif quality == '1':
        return 'TS'
    elif quality == '2':
        return 'TELESYNC'
    elif quality == '3':
        return 'R5'
    elif quality == '4':
        return 'DVDSCR'
    elif quality == '5':
        return 'DVDRIP'
    elif quality == '6':
        return 'HDTV'
    elif quality == '7':
        return 'BRRIP'
    elif quality == '8':
        return 'BDRIP'
    elif quality == '9':
        return '480P'
    elif quality == '10':
        return '720P'
    elif quality == '11':
        return '1080P'
    elif quality == '12':
        return ''
    else:
        return '720P'

def tvcustom_quality():
    quality = ADDON.getSetting('tvquality')
    if quality == '0':
        return 'CAM'
    elif quality == '1':
        return 'TS'
    elif quality == '2':
        return 'TELESYNC'
    elif quality == '3':
        return 'DVDSCR'
    elif quality == '4':
        return 'DVDRIP'
    elif quality == '5':
        return 'HDTV'
    elif quality == '6':
        return 'BRRIP'
    elif quality == '7':
        return 'BDRIP'
    elif quality == '8':
        return '480P'
    elif quality == '9':
        return '720P'
    elif quality == '10':
        return '1080P'
    elif quality == '11':
        return ''
    else:
        return '720P'
		
def preferred_tv2():
    if ADDON.getSetting('search_tvquality_2') == "true":
        return True
    else:
        return False
		
def tvcustom_quality2():
    quality = ADDON.getSetting('tvquality2')
    if quality == '0':
        return 'CAM'
    elif quality == '1':
        return 'TS'
    elif quality == '2':
        return 'TELESYNC'
    elif quality == '3':
        return 'DVDSCR'
    elif quality == '4':
        return 'DVDRIP'
    elif quality == '5':
        return 'HDTV'
    elif quality == '6':
        return 'BRRIP'
    elif quality == '7':
        return 'BDRIP'
    elif quality == '8':
        return '480P'
    elif quality == '9':
        return '720P'
    elif quality == '10':
        return '1080P'
    elif quality == '11':
        return ''
    else:
        return '720P'

def newmovie_days():
    newmovdays = ADDON.getSetting('newmovdays')
    if newmovdays == '9':
        return 360
    elif newmovdays == '8':
        return 300
    elif newmovdays == '7':
        return 240
    elif newmovdays == '6':
        return 180
    elif newmovdays == '5':
        return 150
    elif newmovdays == '4':
        return 120
    elif newmovdays == '3':
        return 90
    elif newmovdays == '2':
        return 60
    elif newmovdays == '1':
        return 30
    else:
        return 14
		
def furk_search_myfiles():
    if ADDON.getSetting('furk_search_myfiles') == "true":
        return True
    else:
        return False

def imdb_filter_release():
    if ADDON.getSetting('release_date') == "true":
        try:
            from_date = ADDON.getSetting('release_date_from')
            to_date = ADDON.getSetting('release_date_to')
            return "%s,%s" % (from_date, to_date)
        except:
            return ","
    else:
        return ","

def imdb_filter_rating():
    if ADDON.getSetting('user_rating') == "true":
        try:
            rating_min = ADDON.getSetting('user_rating_min')
            rating_max = ADDON.getSetting('user_rating_max')
            return "%s,%s" % (rating_min, rating_max)
        except:
            return ","
    else:
        return ","
    
def imdb_filter_votes():
    if ADDON.getSetting('number_of_votes') == "true":
        try:
            votes_min = ADDON.getSetting('number_of_votes_min')
            votes_max = ADDON.getSetting('number_of_votes_max')
            return "%s,%s" % (votes_min, votes_max)
        except:
            return "1000,"
    else:
        return "1000,"

def imdb_results():
    limit = ADDON.getSetting('number_of_results')
    if limit == '0':
        return 25
    elif limit == '1':
        return 50
    elif limit == '2':
        return 100
    elif limit == '3':
        return 150
    elif limit == '4':
        return 200
    else:
        return 250

	
def imdb_user():
    return ADDON.getSetting('imdb_user')

def imdb_list1():
    return ADDON.getSetting('imdb_list1')
	
def imdb_listname1():
    return ADDON.getSetting('imdb_listname1')
	
def imdb_list2():
    return ADDON.getSetting('imdb_list2')
	
def imdb_listname2():
    return ADDON.getSetting('imdb_listname2')
	
def imdb_list3():
    return ADDON.getSetting('imdb_list3')
	
def imdb_listname3():
    return ADDON.getSetting('imdb_listname3')
	
def imdb_list4():
    return ADDON.getSetting('imdb_list4')
	
def imdb_listname4():
    return ADDON.getSetting('imdb_listname4')
	
def imdb_list5():
    return ADDON.getSetting('imdb_list5')
	
def imdb_listname5():
    return ADDON.getSetting('imdb_listname5')
	
def imdb_list6():
    return ADDON.getSetting('imdb_list6')
	
def imdb_listname6():
    return ADDON.getSetting('imdb_listname6')
	
def imdb_list7():
    return ADDON.getSetting('imdb_list7')
	
def imdb_listname7():
    return ADDON.getSetting('imdb_listname7')
	
def imdb_list8():
    return ADDON.getSetting('imdb_list8')
	
def imdb_listname8():
    return ADDON.getSetting('imdb_listname8')
	
def imdb_list9():
    return ADDON.getSetting('imdb_list9')
	
def imdb_listname9():
    return ADDON.getSetting('imdb_listname9')
	
def imdb_list10():
    return ADDON.getSetting('imdb_list10')
	
def imdb_listname10():
    return ADDON.getSetting('imdb_listname10')

def furk_account():
    if ADDON.getSetting('furk_account') == "true":
        return True
    else:
        return False

def furk_user():
    return ADDON.getSetting('furk_user')
    
def furk_pass():
    return ADDON.getSetting('furk_pass')
	
def furk_limit_file_size():
    if ADDON.getSetting('furk_limit_file_size') == "true":
        return True
    else:
        return False

def furk_limit_fs_num():
    furk_limit_fs_num = ADDON.getSetting('furk_limit_fs_num')
    if furk_limit_fs_num == '6':
        return 10
    elif furk_limit_fs_num == '5':
        return 7.5
    elif furk_limit_fs_num == '4':
        return 5
    elif furk_limit_fs_num == '3':
        return 4
    elif furk_limit_fs_num == '2':
        return 3
    elif furk_limit_fs_num == '1':
        return 2
    else:
        return 1
		
def furk_limit_fs_min():
    furk_limit_fs_min = ADDON.getSetting('furk_limit_fs_min')
    if furk_limit_fs_min == '5':
        return 262144000
    elif furk_limit_fs_min == '4':
        return 209715200
    elif furk_limit_fs_min == '3':
        return 157286400
    elif furk_limit_fs_min == '2':
        return 104857600
    elif furk_limit_fs_min == '1':
        return 52428800
    else:
        return 0
		
def furk_limit_file_size_tv():
    if ADDON.getSetting('furk_limit_file_size_tv') == "true":
        return True
    else:
        return False
		
def furk_limit_fs_num_tv():
    furk_limit_fs_num = ADDON.getSetting('furk_limit_fs_num_tv')
    if furk_limit_fs_num == '9':
        return 10
    elif furk_limit_fs_num == '8':
        return 7.5
    elif furk_limit_fs_num == '7':
        return 5
    elif furk_limit_fs_num == '6':
        return 4
    elif furk_limit_fs_num == '5':
        return 3
    elif furk_limit_fs_num == '4':
        return 2
    elif furk_limit_fs_num == '3':
        return 1
    elif furk_limit_fs_num == '2':
        return 0.75
    elif furk_limit_fs_num == '1':
        return 0.5
    else:
        return 0.25

def subscription_update():
    if ADDON.getSetting('subscription_update') == "true":
        return True
    else:
        return False
    
        
def download_meta():
    if ADDON.getSetting('download_meta') == "true":
        return True
    else:
        return False
    
def movies_directory():
    return ADDON.getSetting('movies_directory')
    
def tv_show_directory():
    return ADDON.getSetting('tv_shows_directory')
		
def movies_download_directory():
    return ADDON.getSetting('movies_download_directory')
	
def temp_download_directory():
    return ADDON.getSetting('temp_download_directory')
		
def tv_download_directory():
    return ADDON.getSetting('tv_download_directory')
		
def music_download_directory():
    return ADDON.getSetting('music_download_directory')

def play_mode():
    return 'stream'

def dummy_path():
    return os.path.join(ADDON.getAddonInfo('path'), 'dummy.wma')

def service_sleep_time():
    return 10

def subscription_timer():
    return int(ADDON.getSetting('subscription_timer'))


def use_fanart():
    if ADDON.getSetting('use_fanart') == 'true':
        return True
    else:
        return False
    

	
def create_directory(dir_path, dir_name=None):
    if dir_name:
        dir_path = os.path.join(dir_path, dir_name)
    dir_path = dir_path.strip()
    if not os.path.exists(dir_path):
        os.makedirs(dir_path)
    return dir_path

def create_file(dir_path, file_name=None):
    if file_name:
        file_path = os.path.join(dir_path, file_name)
    file_path = file_path.strip()
    if not os.path.exists(file_path):
        f = open(file_path, 'w')
        f.write('')
        f.close()
    return file_path
	
create_directory(DATA_PATH, "")

		
